Subject: Re: bug#70594: 30.0.50; Error when tabbing with only one active widget

From: Stephen Berman <[email-masked]>
Date: Sat, 25 May 2024 11:30:01 +0200

On Sat, 25 May 2024 10:42:33 +0300 Eli Zaretskii <[email-masked]> wrote:

> Ping! Ping!  Can we please make some progress here?

Since the patch fixes (according to me testing) a clear bug, either the
patch should be installed (or a better one, if someone comes up with
one) or commit 91333dacfa1, which introduced the bug, should be
reverted; my preference is to install the patch.

Steve Berman

>> Cc: [email-masked]
>> Date: Thu, 09 May 2024 10:23:13 +0300
>> From: Eli Zaretskii <[email-masked]>
>>
>> Ping!
>>
>> > Cc: [email-masked]
>> > Date: Fri, 26 Apr 2024 18:02:13 +0300
>> > From: Eli Zaretskii <[email-masked]>
>> >
>> > > Date: Fri, 26 Apr 2024 14:43:42 +0200
>> > > From:  Stephen Berman via "Bug reports for GNU Emacs,
>> > >  the Swiss army knife of text editors" <[email-masked]>
>> > >
>> > > Commit 91333dacfa1, which adds the feature of optionally skipping over
>> > > inactive widgets when tabbing (bug#70413), fails to handle buffers that
>> > > contain only one active widget; in that case, pressing TAB or S-TAB
>> > > raises the error "No buttons or fields found".  To reproduce:
>> > >
>> > > 0. emacs -Q
>> > > 1. Load the attached file widget-test.el and then type `M-x
>> > >    my-widget-test'.
>> > > 2. In the buffer "*My Widget Test*" repeatedly press TAB and S-TAB and
>> > >    observe that point moves successively between the active radio
>> > >    buttons labelled "One" and "Two" and the active push button "Submit",
>> > >    but skips the inactive push button "Reset", since the user option
>> > >    widget-skip-inactive is enabled.
>> > > 3. Now press (via RET or mouse-click) the "Submit" button, which makes
>> > >    the radio buttons and the "Submit" button inactive and the "Reset"
>> > >    button active.
>> > > 4. Pressing TAB once moves point to the "Reset" button, then pressing
>> > >    TAB again moves point to BOB and raises the error "No buttons or
>> > >    fields found".  Likewise, pressing S-TAB once moves point to "Reset",
>> > >    then pressing S-TAB again moves to EOB and raises the same error.
>> > >
>> > > The attached patched fixes this bug.  In addition, when only one widget
>> > > is active and point is on it, since pressing TAB or S-TAB does not move
>> > > point, the informational message "Only one tabable widget" is displayed.
>> > >
>> > > The original code in widget-move contained separate loops to handle
>> > > forward and backward movement and this involved some code duplication.
>> > > The changes to this code to fix the bug would have required further
>> > > duplication, so I took the opportunity to parameterize the
>> > > directionality, allowing handling both directions in a single loop.
>> > > This shortens the code and IMO makes the similarities and differences in
>> > > the handling easier to see.
>> >
>> > Adding Mauro to the discussion.
>> >
>> >
>> >
>> >
>>
>>
>>
>>